View Issue Details

IDProjectCategoryView StatusLast Update
0029764CommunityOCCT:Foundation Classespublic2018-06-29 21:18
ReporterPawel Assigned Toabv  
PrioritynormalSeverityminor 
Status closedResolutionfixed 
PlatformWindowsOSVC++ 2012 
Product Version7.3.0 
Target Version7.3.0Fixed in Version7.3.0 
Summary0029764: Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Visual Studio Linker bug with enabled CLI
DescriptionIn a C++ mixed-mode assembly (VS2012) instantiating TColStd_MapIteratorOfPackedMapOfInteger gives a linker error: LNK2022: metadata operation failed (8013119F) : A TypeRef exists which should, but does not, have a corresponding TypeDef: (TColStd_intMapNode).

In order to resolve this problem I have to compile TColStd_PackedMapOfInteger.cxx within the project.

I observe this problem with OCCT 7.3.0 Beta
Steps To Reproduce
//compile with /clr
#pragma comment (lib , "TKernel.lib")

#include <TColStd_HPackedMapOfInteger.hxx>
#include <TColStd_MapIteratorOfPackedMapOfInteger.hxx>

int _tmain(int argc, _TCHAR* argv[])
{
Handle_TColStd_HPackedMapOfInteger hMap = new TColStd_HPackedMapOfInteger();
TColStd_MapIteratorOfPackedMapOfInteger itr(hMap->Map());
return 0;
}
TagsNo tags attached.
Test case numberNot needed

Relationships

child of 0029376 closedbugmaster Open CASCADE Coding Rules, TColStd_PackedMapOfInteger - declare Iterator as nested class of map collection 

Activities

git

2018-05-14 15:34

administrator   ~0075961

Branch CR29764 has been created by kgv.

SHA-1: 95693289805aaaa1aa6d9f1258087a4f20d4ebd8


Detailed log of new commits:

Author: kgv
Date: Mon May 14 15:33:55 2018 +0300

    0029764: Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Linker error with Common Language Runtime enabled

git

2018-05-14 15:35

administrator   ~0075962

Branch CR29764 has been updated forcibly by kgv.

SHA-1: 062c5abe0d2be7a8bd4139d22fb2a8df3bee2a84

kgv

2018-05-14 16:55

developer   ~0075967

Please take a look onto workaround in the patch.

http://jenkins-test-11.nnov.opencascade.com/view/CR29764-master-KGV/

abv

2018-05-23 14:06

manager   ~0076169

No remarks, please integrate

bugmaster

2018-05-23 16:24

administrator   ~0076185

Combination -
OCCT branch : CR29764 SHA - 062c5abe0d2be7a8bd4139d22fb2a8df3bee2a84
Products branch : master SHA - 300cf879a836fb8a5c4636713070ca9cf544749f
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian70-64:
OCCT
Total CPU difference: 18303.059999999845 / 18243.73999999987 [+0.33%]
Products
Total CPU difference: 7513.160000000051 / 7505.440000000054 [+0.10%]
Windows-64-VC10:
OCCT
Total CPU difference: 17956.57310549851 / 18049.78370299853 [-0.52%]
Products
Total CPU difference: 7679.991630399949 / 7697.713343999945 [-0.23%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention

git

2018-06-23 13:56

administrator   ~0076945

Branch CR29764 has been deleted by kgv.

SHA-1: 062c5abe0d2be7a8bd4139d22fb2a8df3bee2a84

Related Changesets

occt: master 3d77e962

2018-05-14 12:33:55

abv


Committer: abv Details Diff
0029764: Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Visual Studio Linker bug with enabled CLI Affected Issues
0029764
mod - src/TColStd/TColStd_PackedMapOfInteger.cxx Diff File
mod - src/TColStd/TColStd_PackedMapOfInteger.hxx Diff File

Issue History

Date Modified Username Field Change
2018-05-14 14:51 Pawel New Issue
2018-05-14 14:51 Pawel Assigned To => mpv
2018-05-14 14:57 Pawel Target Version 7.4.0 => 7.3.0
2018-05-14 15:33 kgv Assigned To mpv => abv
2018-05-14 15:33 kgv Category OCCT:Application Framework => OCCT:Foundation Classes
2018-05-14 15:33 kgv Summary Linker problem when compiling with Common Language Runtime Support => Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Linker error with Common Language Runtime enabled
2018-05-14 15:33 kgv Steps to Reproduce Updated
2018-05-14 15:34 git Note Added: 0075961
2018-05-14 15:35 kgv Summary Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Linker error with Common Language Runtime enabled => Foundation Classes, TColStd_MapIteratorOfPackedMapOfInteger - workaround Visual Studio Linker bug with enabled CLI
2018-05-14 15:35 git Note Added: 0075962
2018-05-14 15:38 kgv Relationship added child of 0029376
2018-05-14 16:55 kgv Note Added: 0075967
2018-05-14 16:55 kgv Status new => resolved
2018-05-23 14:06 abv Note Added: 0076169
2018-05-23 14:06 abv Assigned To abv => bugmaster
2018-05-23 14:06 abv Status resolved => reviewed
2018-05-23 16:24 bugmaster Test case number => Not needed
2018-05-23 16:24 bugmaster Note Added: 0076185
2018-05-23 16:24 bugmaster Status reviewed => tested
2018-05-24 16:02 abv Changeset attached => occt master 3d77e962
2018-05-24 16:02 abv Assigned To bugmaster => abv
2018-05-24 16:02 abv Status tested => verified
2018-05-24 16:02 abv Resolution open => fixed
2018-06-23 13:56 git Note Added: 0076945
2018-06-29 21:13 aiv Fixed in Version => 7.3.0
2018-06-29 21:18 aiv Status verified => closed